﻿using System;
using System.Windows.Forms;
using System.Threading;//aggiungere questa riga per i delay

namespace lavoriamo_sulle_coordinate
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        string cmdbase, cmdspalla, cmdgomito, cmdpolso, cmdpinza;
      
        int tempo1 = 200;
        int tempo2 = 500;
       
        double x,y,z;

        double distbase = 9.5f;

        double L1 = 15.5;
        double L2 = 10;
        double d, dz;

        double tgfi, firad, tgdelta, deltarad;
        double cosalfa, cosbeta, cosgamma;
        double arcocosbeta, arcocosalfa, arcocosgamma;
        double alfagradi, betagradi, figradi, deltagradi, gammagradi;
        double mappolso, mapspalla, mapgomito, mapbase;
        string spallastring, gomitostring, basestring, polsostring;


        float trim=0.9f;       

        private void cmdinvia_Click(object sender, EventArgs e)
        {
            // acquisizione dei dati di calcolo*****************
            x = double.Parse(textX.Text);
            y = double.Parse(textY.Text);
            z = double.Parse(textZ.Text);
            
            //ricava d e dz*************************************
            d = Math.Sqrt((x * x) + ((y + distbase) * (y + distbase)));
            dz = Math.Sqrt((d * d) + (z * z));

            // calcolo dell'angolo del motore della base *******
            tgfi = x / (y + distbase);
            //calcolo tangente in rad
            firad = Math.Atan(tgfi);
           //trasformazione in gradi e arrotondamento
            figradi = Math.Round((180 * firad) / 3.14);
            //mappatura dei gradi con i valori di taratura         
            mapbase = -0.88 * figradi+ 93;
            //formattazione del risultato
            basestring = mapbase.ToString("000");
         
           //impostazione del comando da inviare sulla seriale
            cmdbase = "0" + basestring + "Z";
            //scrittura del valore nella label cmdbase
            lblcmdbase.Text = cmdbase;

            //calcolo dell'angolo da aggiungere alla spalla****
            tgdelta = z / d;
            deltarad = Math.Atan(tgdelta);
            deltagradi= Math.Round((180 * deltarad) / 3.14);
           
           
            // calcolo dell'angolo del motore della spalla***************
            cosgamma = (-(L1 * L1) + (dz * dz) + (L2 * L2)) / (2 * dz * L2);
            arcocosgamma = Math.Acos(cosgamma);
            gammagradi = Math.Round(((arcocosgamma * 180) / 3.14)+deltagradi); 
            //si somma anche l'angolo di z della spalla deltagradi
            mapspalla = 0.86 *gammagradi*trim + 53;//53
            spallastring = mapspalla.ToString("000");
            cmdspalla = "1"+ spallastring + "Z";
            lblcmdspalla.Text = cmdspalla;          

               // calcolo dell'angolo del motore del gomito***************
               cosbeta = (-(dz * dz) + (L1 * L1) + (L2 * L2)) / (2 * L1 * L2);
               arcocosbeta = Math.Acos(cosbeta);
               betagradi = Math.Round((arcocosbeta * 180) / 3.14);
               mapgomito = -0.9 * betagradi*trim+ 180;//180
               gomitostring = mapgomito.ToString("000");
               cmdgomito = "2" + gomitostring + "Z";
               lblcmdgomito.Text = cmdgomito;

           // calcolo dell'angolo del motore del polso
           cosalfa = (-(L2 * L2) + (dz * dz) + (L1 * L1)) / (2 * dz * L1);
           arcocosalfa = Math.Acos(cosalfa);
           alfagradi = Math.Round((arcocosalfa * 180) / 3.14);
           mappolso=-1.1*alfagradi*1.2+160;//1.3 è la correzione dell'angolo
           polsostring = mappolso.ToString("000");
           cmdpolso = "3" + polsostring + "Z" ; 
           lblcmdpolso.Text = cmdpolso;


           cmdpinza="4"+"140"+"Z";

            serialPort1.Open();
            serialPort1.Write(cmdbase);
            Thread.Sleep(tempo2);
           
            serialPort1.Write(cmdspalla);          
            Thread.Sleep(tempo2);

            serialPort1.Write(cmdgomito);
            Thread.Sleep(tempo2);

            serialPort1.Write(cmdpolso);
                        Thread.Sleep(tempo2);
            serialPort1.Close();
        }
        private void cmdtaratura_Click(object sender, EventArgs e)
        {           
            taratura();
            Thread.Sleep(tempo2);           
        }

        private void cattura()
        {           
            serialPort1.Open();
            serialPort1.Write("4" + "080" + "Z");//chiude pinza
            Thread.Sleep(tempo2);

            serialPort1.Write("2" + "070" + "Z");//alza gomito
           
            Thread.Sleep(tempo2);

            serialPort1.Write("1" + "107" + "Z");//alza gomito
           
            Thread.Sleep(tempo2);

            serialPort1.Write("0" + "055" + "Z");//gira base
           
            Thread.Sleep(tempo2);

            serialPort1.Write("2" + "115" + "Z" );//abbassa gomito
           
            Thread.Sleep(tempo2);

            serialPort1.Write("3" + "115" + "Z");//piega polso
           
            Thread.Sleep(tempo2);

            serialPort1.Write("4" + "140" + "Z" );//apre pinza
            Thread.Sleep(tempo2);

            serialPort1.Write("3" + "070" + "Z" );//alza polso           
            Thread.Sleep(tempo2);

            serialPort1.Close();
        }

        private void taratura()
        {            
            serialPort1.Open();
            cmdbase = "0" + "93" + "Z";
            Thread.Sleep(tempo1);
            cmdpolso = "3" + "065" + "Z";
            Thread.Sleep(tempo1);
            cmdspalla = "1" + "130" + "Z" ;
            Thread.Sleep(tempo1);
            cmdgomito = "2" + "095" + "Z" ;
            Thread.Sleep(tempo1);
         
            cmdpinza = "4" + "140" + "Z" ;
            Thread.Sleep(tempo1);

           lblcmdbase.Text = cmdbase+"T";
           lblcmdspalla.Text = cmdspalla + "T";
           lblcmdgomito.Text = cmdgomito + "T";
           lblcmdpolso.Text = cmdpolso + "T";

            serialPort1.Write(cmdpolso);
            Thread.Sleep(tempo2);

            serialPort1.Write(cmdgomito);
            Thread.Sleep(tempo2);

            serialPort1.Write(cmdspalla);
            Thread.Sleep(tempo2);

            serialPort1.Write(cmdbase);
            Thread.Sleep(tempo2);

            //sempre mettere un delay per evitare malfunzionamenti
            
            serialPort1.Write(cmdpinza);
            Thread.Sleep(tempo2);
                      
            serialPort1.Close();
        }

        private void cmdcattura_Click(object sender, EventArgs e)
        {           
            cattura();           
        }       
    }
}
